
       Basic instructions for building the library using CMake


       Copyright (C) 2001-2006 Universitat Pompeu Fabra - Barcelona (Spain)

  
       Homepage: http://www.tecn.upf.es/gti/openMOIV/
       Contact:  openmoiv@upf.es


Introduction:
=============

With cmake tool and the supplied CMakeLists.txt file you can generate the project files 
for your platform.


Instructions:
=============

You should be able to build the library if you have the following
components installed on your system:

- CMake compile tool (http://www.cmake.org)
- Open Inventor Library compatible (SGI,TGS,Coin,OSS-SGI)

You must define the following environment variables (win32 and UNIX only):

- OIV_DIR: Open Inventor root directory (Inventor Toolkit, OSS Open Inventor, SIM Coin or TGS Open Inventor)

CMake tutorials can be downloaded from http://www.cmake.org.


CMake project file instructions
===============================

Typical command: "cmake . [-Dshared:int=1] [-Dcoin:int=1] -D[sys_fonts | no_libFL]"

- Use -Dshared:int=1 (optional argument, default: static library) 
if you want to generate a MSWindows DLL (.dll) or a linux shared object (.so).

- Use -Dcoin:int=1 (optional argument, OSS Open Inventor by default) 
if you want to link with SIM Coin.

- Use -Dsys_fonts:int=1 (optional argument, default: SGI FL font library) 
if you want to create fonts using wgl/glx extensions.

- Use -Dno_libFL:int=1 (optional argument, default: SGI FL font library) 
if you want to use a hardcoded font.


Examples for Win32
==================
"cmake . -Dshared:int=1 -Dsys_fonts:int=1" (generate a DLL project, use system fonts and use OSS Open Inventor)
"cmake . -Dcoin:int=1" (generate a static LIB project and use Coin as Open Inventor library)
"cmake . -Dshared:int=1 -Dno_libFL:int=1" (generate a DLL project and use hardcoded font)


Examples for Linux and IRIX
===========================
"cmake . -Dshared:int=1 -Dcoin:int=1" (generate a shared library makefile and use Coin as Open Inventor library)
"cmake . " (generate a static library makefile and use SGI font library)

Examples for MacOS X
===========================
"cmake . " (generate a static library makefile and use Coin as Open Inventor library)
"cmake . -Dshared:int=1" (generate a shared library makefile and use Coin as Open Inventor library)

It's mandatory to use Coin as Open Inventor library in MacOS X.
It's mandatory to use one hardcoded font in MacOS X. System fonts support will be added in future releases.


Contact Info:
=============

If you are having problems generating your project files, don't hesitate and contact us.

E-mail: openmoiv@upf.es
Homepage: http://www.tecn.upf.es/gti/openMOIV
Universitat Pompeu Fabra - GTI  2006
Passeig de Circumvallaci N8 08003 Barcelona
Tel:(34) 93 5422500 or (34) 93 5422201 Fax:(34) 93 5422202


[end of file]
